.MEMORYMAP                              ; vic 20 memory config for wla6510
DEFAULTSLOT 0
SLOTSIZE $ffff
SLOT 0 $0000
.ENDME

.ROMBANKMAP
BANKSTOTAL 1
BANKSIZE $ffff
BANKS 1
.ENDRO

.BANK 0

;****************************************************************************
;*****
;*****  
;*****  1K TAMMERFORS (1024 bytes)
;*****  
;*****  Racing Game for Unexpanded VIC 20
;*****
;*****  (c)2003 Aleksi Eeben (http://www.cncd.fi/aeeben)
;*****  
;*****
;*****  Written for the 2003 MiniGame Competition (http://www.ffd2.com)
;*****
;*****
;****************************************************************************


;-----  zero page variables

.DEFINE scroll          $00

.DEFINE score           $01
.DEFINE score100        $02

.DEFINE time            $03
.DEFINE trip            $04

.DEFINE season          $05
.DEFINE carx            $06

.DEFINE speed           $07
.DEFINE timecount       $08

.DEFINE scr             $09
.DEFINE scrh            $0a
.DEFINE tmp             $0b

.DEFINE seasoncolor     $0c
.DEFINE orm             $0d

.DEFINE framescroll     $0e

.DEFINE cpucars         $0f             ; $0f-$13
.DEFINE cpucarspd       $14             ; $14-$18


;-----  cbm binary load address

.ORG $0
.SECTION "BANKHEADER"
        .dw     $1001
.ENDS


;-----  main

.ORG $1001
.SECTION "main" FORCE

        .DB     $0b,$10,$01,$00,$9e,$34,$31,$30,$37,$00

entry:
        ldx     #$00
        stx     $9002
        txa
_inilp
        sta     $80,x                   ; wraps, zero $00-$80
        sta.w   $1d00,x
        dex
        bmi     _inilp

        stx     $9122                   ; $7f, set joy3 input

        jsr     $e55f                   ; clear screen

        ldx     #$05
_prlp
        ldy     #$00
        jsr     print                   ; draw road
        dex
        bpl     _prlp

        jsr     print                   ; draw score line

        sei
        txa
_sfcl
        sta     $14ff,x                 ; $ff
        dex
        bne     _sfcl

        ldy     #$20
        sty     time

_sflp
        lda.w   graphics+$9f,y          ; pre-draw cpu cars
        sta     $1500,y
        lda.w   graphics+$bf,y
        sta     $1540,y
        dey
        bne     _sflp

        lda     #$15
        sta     scrh
        sta     tmp+1
        lda     #$81
        sta     tmp

        ldx     #$08
_pag
        lda     (scr),y                 ; 16 pre-shifted images
        sta     (tmp),y
        iny
        bne     _pag

        inc     scrh
        inc     tmp+1
        dex
        bne     _pag

        jsr     changeseason


;-----  main loop

mainloop:
        lda     speed
        ora     time
        bne     _gameon

        lda     $9111
        and     #$20
        beq     entry

        bne     _nocars
_gameon


;-      move other cars

        ldx     #$04
        stx     $9000

_nextcar
        jsr     locate


;-      wipe car

        ldy     #$00
        jsr     collisionwipe

        cmp     #$f0
        bcs     _carwok

        ldy     #$1e
        jsr     collisionwipe

        cmp     #$e0
        bcs     _carwok

        ldy     #$3c
        jsr     collisionwipe
_carwok

;-      move car

        lda     speed
        lsr
        lsr
        sec
        sbc     cpucarspd,x
        clc
        adc     cpucars,x

        cmp     #$20
        bcs     _nonewcar

        lda     $9118
        and     #$03

        cpx     $9114
        bne     _nonewcar

        adc     season
        sta     cpucarspd,x

        lda     #$1f
_nonewcar
        sta     cpucars,x


;-      draw car

        jsr     locate

        lda     cpucars,x
        and     #$0f
        asl
        asl
        asl
        adc     #$10

        ldy     #$00
        sta     (scr),y
        ora     #$04
        iny
        sta     (scr),y

        ldy     cpucars,x
        cpy     #$f0
        bcs     _carok

        ldy     #$1e
        eor     #$05
        sta     (scr),y
        ora     #$04
        iny
        sta     (scr),y

        ldy     cpucars,x
        cpy     #$e0
        bcs     _carok

        ldy     #$3c
        eor     #$07
        sta     (scr),y
        ora     #$04
        iny
        sta     (scr),y

_carok
        dex
        bpl     _nextcar
_nocars


;-      top of screen

        lda     seasoncolor

        ldx     #$24
        stx     $9001
_wtop
        cpx     $9004
        bne     _wtop

        sta     $900f

        lda     #$9e
        sta     $9002


;-      update score line numbers

        ldx     #$0c
        lda     score
        jsr     writebcd
        lda     score100
        jsr     writebcd

        ldx     #$1c
        lda     trip
        jsr     writebcd


;-      wipe player car

        lda     carx
        lsr
        lsr
        tax

        ldy     #$02

        lda     carx
        and     #$03
        beq     _no3w

        lda     #$13
_wipc
        sta     $1ef7,x
        sta     $1f15,x
        inx
_no3w
        dey
        bpl     _wipc


;-      run timer

        lda     time
        beq     _notime

        dec     timecount
        bne     _nosecond

        ldx     #$32
        stx     timecount

        jsr     decbcd
        sta     time

_nosecond
        ldx     #$14
        jsr     writebcd


;-      check joystick and move

        lda     $9111                   ; check joystick
        ror
        ror                             ; joystick up to carry
        ror
        bcs     _nospeedup

        bit     speed                   ; top speed $40
        bvs     _nospeedup
        inc     speed
_nospeedup
        ror                             ; joystick down to carry

        ldy     speed                   ; can't move l/r/d if no speed
        beq     _notmoving

        bcs     _nobrake

        dec     speed
_nobrake
        ldx     carx
        beq     _notleft                ; left limit

        ror                             ; joystick left to carry
        bcs     _notleft

        dec     carx

_notleft
        cpx     #$38                    ; right limit
        beq     _notright

        lda     $9120                   ; check joystick right
        bmi     _notright

        inc     carx
_notright

_notmoving
        tya
_notime
        adc     #$7e
        sta     $900b


;-      draw car softsprite

        ldx     #$1f
_shiftlp
        lda.w   graphics+$a0,x          ; init car softsprite
        sta     $1d00,x
        lda.w   graphics+$c0,x
        sta     $1d20,x
        lda     #$ff
        sta     $1d40,x

        lda     carx                    ; bit shifts
        and     #$03
        beq     _noshift

        asl
        tay
_shi
        sec
        ror     $1d00,x
        ror     $1d20,x
        ror     $1d40,x
        dey
        bne     _shi
_noshift
        dex
        bpl     _shiftlp


        lda     carx
        lsr
        lsr
        tax

        lda     #$03
        sta     tmp

        ldy     #$8f

        lda     carx
        and     #$03
        beq     _no3d

_carlp
        iny
        tya
        sta     $1ef7,x
        iny
        tya
        sta     $1f15,x
        inx
_no3d
        dec     tmp
        bne     _carlp


;-      bottom of screen

        lda     #$08
        ldy     #$1a
        ldx     #$83
_wbot
        cpx     $9004
        bne     _wbot

        ldx     #$19
_timin
        dex
        bne     _timin

        .DB     $ea

        ldx     #$f2

        sty     $9003
        sta     $900f
        stx     $9005


;-      scroll road

        lda     scroll                  ; fine scroll
        sec
        sbc     speed
        sta     scroll
        bcs     _noadv

        ldx     #$01                    ; +1 score

        lda     speed
        beq     _nodec
        dec     speed
_nodec

        lda     trip                    ; trip meter
        jsr     decbcd
        sta     trip
        bne     _noseason

        jsr     changeseason

_noseason
        sed
        clc
        txa
        adc     score
        sta     score
        lda     #$00
        adc     score100
        sta     score100
        cld

_noadv
        lda     scroll
        lsr
        lsr
        and     #$1f
        tay

        ldx     #$60
_nextorm
        stx     orm                     ; bits 7-5 of tile offset

        lda     #$20
        sta     tmp

_scrlp
        tya                             ; wrap within tile
        and     #$1f
        ora     orm
        tay

        lda.w   graphics-$60,y
        sta     $1420-$60,x

        iny
        inx

        dec     tmp
        bne     _scrlp

        txa                             ; flags
        bne     _nextorm

        lda     #$1b
        sta     $9003
        lda     #$fd
        sta     $9005

        jmp     mainloop
        


;-----  write bcd number

writebcd:
        pha
        jsr     _bcdone

        pla
        lsr
        lsr
        lsr
        lsr
_bcdone
        dex
        and     #$0f
        ora     #$30
        sta     $1f68,x
        rts


;-----  change season

changeseason:
        lda     season
        and     #$03
        tax
        lda.w   seasons,x
        sta     $900e
        and     #$0f
        sta     seasoncolor

        ldx     time                    ; time left to score
        txa

        sed
        clc
        adc     #$10                    ; extra time
        sta     time
        cld

        sta     timecount

        lda     #$90
        sta     trip

        inc     season
        rts


;-----  locate other car

locate:
        lda     cpucars,x

        and     #$f0
        sta     scr                     ; x * 16

        lsr
        lsr
        lsr
        adc     #$3c+$3c
        sec
        sbc.w   cpucarx,x
        sta     tmp                     ; x * 2 - $3c - $3c

        asl     scr
        lda     #$1e
        adc     #$00
        sta     scrh                    ; x * 32 + $1e00

        lda     scr
        sec
        sbc     tmp
        sta     scr
        bcs     _nolch

        dec     scrh                    ; x * 30 + $1e00 - $3c - $3c
_nolch
        rts


;-----  wipe one line of cpu car and check collisions

collisionwipe:
        jsr     _coll
        iny
_coll
        lda     (scr),y
        cmp     #$90
        bcc     _nocrash

        lda     #$00
        sta     speed
        sta     time

_nocrash
        lda     #$13
        sta     (scr),y

        lda     cpucars,x
        rts


;-----  draw many @'s

row:
        sty     tmp

        tay
        lda     #$53
_rowlp
        jsr     $ffd2
        iny
        bne     _rowlp

        ldy     tmp
        ;
        ;
;-----  screen draw

print:
        iny
        lda.w   tmap-1,y
        bmi     row
        cmp     #$10
        bcs     _nocol
        sta     $286
_nocol
        jsr     $ffd2
        bne     print
        ;                               ; the code below does no harm
        ;
;-----  decrement bcd number

decbcd:
        sed
        sec
        sbc     #$01
        cld
        rts


;-----  data

graphics:
        .INCBIN "graphics.bin"

tmap:
        .DB     9,"FH",15,"J",9,"GI",15,"KD",9
        .DB     $f0
        .DB     15,"C",9,"GI",15,"K",9,"FH",15,"J"

        .DB     9,"GI",15,"K",9,"FH",15,"JE",9
        .DB     $f0
        .DB     15,"B",9,"FH",15,"J",9,"GI",15,"K",0

text:
        .DB     1,"  sCORE:",$fc," tIME:",$fe," tRIP:",0

cpucarx:
        .DB     $08,$0b,$0e,$11,$14
seasons:
        .DB     $85,$87,$e3,$45
.ENDS
